
risk_free = read.csv("risk_free.csv")
risk_free = risk_free[, 2]

risk_parameter = 1.68

turn_over = 0.5

max_position = 0.5

calculate_weight_CVXR = function(mu, sigma, risk_parameter, w_lag = NULL) {
    # this function computes weight by constraint
    n = length(mu)
    mu = matrix(mu, n, 1)
    weight = Variable(n)
    objective <- Minimize(-t(weight) %*% mu +
                          (risk_parameter / 2) * quad_form(weight, sigma))

    if (is.null(w_lag)) {
        lb = 0
        ub = max_position
        prob <- Problem(objective,
                    constraints = list(weight >= lb, weight <= ub,
                                      sum(weight) >= 1, sum(weight) <= 1
								))
	}else{
        lb = 0
        ub = max_position
        prob <- Problem(objective,
                    constraints = list(weight >= lb, weight <= ub,
                                        sum(weight) >= 1, sum(weight) <= 1, 
                                        sum(abs(weight - w_lag)) <= turn_over * 2))

    }
    prob_data <- get_problem_data(prob, solver = "ECOS")

    solver_output <- ECOSolveR::ECOS_csolve(c = prob_data[["c"]],
                                    G = prob_data[["G"]],
                                    h = prob_data[["h"]],
                                    dims = prob_data[["dims"]],
                                    A = prob_data[["A"]],
                                    b = prob_data[["b"]])
    result <- unpack_results(prob, "ECOS", solver_output)
    return(as.vector(result$getValue(weight)))

    # result = 1.0 / risk_parameter * solve

    # return(as.vector(1 / risk_parameter * solve(sigma) %*% mu))
}

